Codeforces Round 928 (Div. 4) (A-E)

这篇具有很好参考价值的文章主要介绍了Codeforces Round 928 (Div. 4) (A-E)。希望对大家有所帮助。如果存在错误或未考虑完全的地方,请大家不吝赐教,您也可以点击"举报违法"按钮提交疑问。

比赛地址 : 

https://codeforces.com/contest/1926

遍历每一个字符串,比较1和0的数量即可,那个大输出那个;

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'
#define lowbit(x) (x&(-x))
#define sz(a) (int)a.size()
#define pb push_back
#define all(a) a.begin(), a.end()
#define int long long
typedef long long LL;
const int mod = 1e9+7;
const int N = 2e5+10;

using namespace std;

inline void solve(){
	int n ; cin >> n ;
	for(int i=1;i<=n;i++){
		string s ; cin >> s ;
		int t = 0 ;
		for(char c : s){
			if(c=='A') t++;
		}
		if(t>=3) cout << "A" << endl;
		else cout << "B" << endl;
	}
}
 
signed main()
{
    IOS
    int _ = 1;
    // cin >> _;
    while(_ --) solve();
    return 0;
}

B . 

模拟,先找第一个出现的'1' , 然后求这一列1的个数(也就是正方形的一条边) : n,然后求'1'的总个数: s,判断n*n==s && 右下角那个点也是1,就能够判断是不是正方形,否则就是三角形 ;

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'
#define lowbit(x) (x&(-x))
#define sz(a) (int)a.size()
#define pb push_back
#define all(a) a.begin(), a.end()
#define int long long
typedef long long LL;
const int mod = 1e9 + 7;
const int N = 2e5 + 10;

using namespace std;

char a[13][13] ;

inline void solve() {
	int n ; cin >> n ;
	int t = 0 ;
	bool tag = true;
	int x = 0 , y = 0 ;
	for(int i=1;i<=n;i++){
		for(int j=1;j<=n;j++){
			cin >> a[i][j] ;
			if(a[i][j]=='1' && tag){
				x = i ;
				y = j ;
				tag = false ;
			}
			if(a[i][j] == '1') t++;
		}
	}
	bool st = false ;
	int b = 0 ;
	for(int j=y;j<=n;j++){
		if(a[x][j]=='1') b++;// 长度		
	}
	if(x+b-1<=n&&y+b-1<=n&&a[x+b-1][y+b-1]=='1') st = true ;
	if(t==b*b && st) cout << "SQUARE" << endl;
	else cout << "TRIANGLE" << endl ;
	
}

signed main()
{
    IOS
        int _ = 1;
    cin >> _;
    while (_--) solve();
    return 0;
}

C

前缀和 + 预处理

可以通过前缀和进行预处理,为O(2e5+n),然后对于每一个数据,都能够通过O(1)进行输出 ;

#include<bits/stdc++.h>
using namespace std;
typedef long long LL ;
const int N = 2e5 + 10 ;
LL a[N] ;

int get(int x){
	int t = 0 ;
	while(x) t+=x%10,x/=10;
	return t ;
}

void init(){
	a[1] = 1 ;
	for(int i=2;i<=2e5;i++){
		a[i] = a[i-1] + get(i) ;
	}
}

int main() {
	int tt ; cin >> tt ;
	init() ;
	while(tt--){
		int n ; cin >> n ;
		cout << a[n] << endl;
	}
	return 0 ;
}

数学 推式子

分情况讨论,推出数学式子 , 然后算出答案 ;

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'
#define lowbit(x) (x&(-x))
#define sz(a) (int)a.size()
#define pb push_back
#define all(a) a.begin(), a.end()
typedef long long LL;
const int mod = 1e9+7;
const int N = 2e5+10;

using namespace std;

LL get0(int n){
	LL ans = (n+1)*n/2 ;
	return ans ;
}
LL get1(int n){
			int x = n / 10 ;
		int y = n % 10 ;
		LL t = x * (x-1) / 2 * 10 + 45 * x + get0(y) + (y+1) * x;
		return t ;
}

LL get2(int n){
	int x = n / 100 ;
		int y = n % 100 ;
		LL t = get1(y) + x * (x-1) / 2 * 100 + x * get1(99) + (y+1) * x;
		return t ;
}
LL get3(int n){
	int x = n / 1000 ;
		int y = n % 1000 ;
		LL t = get2(y) + x * (x-1) / 2 * 1000 + x * get2(999) + (y+1) * x;
		return t ;
}
LL get4(int n){
	int x = n / 10000 ;
		int y = n % 10000 ;
		LL t = get3(y) + x * (x-1) / 2 * 10000 + x * get3(9999) + (y+1) * x;
		return t ;
}

inline void solve(){
	int n ; cin >> n ;
	if(n<10) {
		cout << (n+1)*n/2 << endl;
		return ;
	}
	if(n>=10 && n<100){
		int x = n / 10 ;
		int y = n % 10 ;
		LL t = x * (x-1) / 2 * 10 + 45 * x + get0(y) + (y+1) * x;
		cout << t << endl;
		return ;
	}
	if(n>=100 && n<1000){
		int x = n / 100 ;
		int y = n % 100 ;
		LL t = get1(y) + x * (x-1) / 2 * 100 + x * get1(99) + (y+1) * x;
		cout << t << endl;
		return ;
	}
	if(n>=1000 && n<10000){
		int x = n / 1000 ;
		int y = n % 1000 ;
		LL t = get2(y) + x * (x-1) / 2 * 1000 + x * get2(999) + (y+1) * x;
		cout << t << endl;
		return ;
	}
	if(n>=10000 && n<100000){
		int x = n / 10000 ;
		int y = n % 10000 ;
		LL t = get3(y) + x * (x-1) / 2 * 10000 + x * get3(9999) + (y+1) * x;
		cout << t << endl;
		return ;
	}
	if(n>=100000 && n<1000000){
		int x = n / 100000 ;
		int y = n % 100000 ;
		LL t = get4(y) + x * (x-1) / 2 * 100000 + x * get4(99999) + (y+1) * x;
		cout << t << endl;
		return ;
	}
}
 
signed main()
{
    IOS
    int _ = 1;
    cin >> _;
    while(_ --) solve();
    return 0;
}

D

哈希表 + 位运算

对于每个数来说,能与它一组的有且仅有二进制在低31位上的31位都完全相反这一个数,那么可以得到一个组最多两个数字,对于x,那么能够与它配对的数字也就是 : ((1<<31)-1) ^ x ,其中((1<<31)-1)代表2^31-1,其二进制的低31位全是一;

通过上面就可以一遍遍历,用map记录之前出现过的数,遇到能匹配的,就删掉一个 ;

int yy = (1<<31) - 1 ;
/ 一对中的所有位都不同的条件等价于当我们对 2个数进行异或时,该对产生的数的所有位都设置为 1
inline void solve2(){
	int n ; cin >> n ;
	map<int,int> mp ;
	int ans = 0 ;
	for(int i=1;i<=n;i++){
		int x ; cin >> x ;
		if(!mp[x]) ++ans,++mp[yy^x];
		else --mp[x] ;
	}
	cout << ans << endl ;
}

哈希表 + 字符串

如果不精通位运算,就可以直接采取hash表存字符串的方式;

这里采用set + map进行模拟 ;

LL a[N] ;

string get(string s){
	string str = "" ;
	for(char c : s) str += c == '1' ? '0' : '1' ;
	return str;
}


inline void solve(){
	int n ; cin >> n ;
	for(int i=1;i<=n;i++) cin >> a[i] ;
	set<string> st ;
	map<string,int> mp ;
	int x = 0 ;
	for(int i=1;i<=n;i++){
		string s = bitset<32>(a[i]).to_string();
		s = s.substr(1);
		string str = get(s) ;
		if(st.count(str)){
			x++;
			if(mp[str]>1){
				mp[str]--;
			}else{
				st.erase(str);
				mp[str]--;
			}
		}else{
			st.insert(s) ;
			mp[s]++;	
		}  
	}
	cout << n - x << endl ;
}

E

思维题

对于第一轮,就已经把全部的奇数放完了,那么之后的就全部都是偶数 ;

永远不会在非2的幂的棋步上放下棋 ,因为非2的幂的步上,一定包含一个奇数因子,会在第一轮就被放下 ;

加入上一步还剩n个棋子,那么下一步一定会下其中的一半棋子,然后模拟就好了 ;文章来源地址https://www.toymoban.com/news/detail-833454.html

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'
#define lowbit(x) (x&(-x))
#define sz(a) (int)a.size()
#define pb push_back
#define all(a) a.begin(), a.end()
#define int long long
typedef long long LL;
const int mod = 1e9+7;
const int N = 2e5+10;

using namespace std;

// 第一轮 把奇数放完了,后面一定全是偶数
// 永远不会在非2的幂的棋步上放下棋 ,因为非2的幂的步上,一定包含一个奇数因子,会在第一轮就被放下 ;
  

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> v;
	while (n) {
		v.push_back((n + 1) / 2); //每次放奇数个 
		n /= 2;
	}
	int tot = 0, pow2 = 1;
	for (int x : v) {
		if (tot < k && k <= tot + x) {
			cout << pow2 * (2 * (k - tot) - 1) << '\n';
			return;
		}
		tot += x;
		pow2 *= 2;
	}
}
 
signed main()
{
    IOS
    int _ = 1;
    cin >> _;
    while(_ --) solve();
    return 0;
}

到了这里,关于Codeforces Round 928 (Div. 4) (A-E)的文章就介绍完了。如果您还想了解更多内容,请在右上角搜索TOY模板网以前的文章或继续浏览下面的相关文章,希望大家以后多多支持TOY模板网!

本文来自互联网用户投稿,该文观点仅代表作者本人,不代表本站立场。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如若转载,请注明出处: 如若内容造成侵权/违法违规/事实不符,请点击违法举报进行投诉反馈,一经查实,立即删除!

领支付宝红包 赞助服务器费用

相关文章

  • Codeforces Round 868 Div 2

    要求构造一个仅包含 (1) 和 (-1) 的长度为 (n) 的数组 (a) ,使得存在 (k) 个下标对 ((i, j), i j) 满足 (a_i times a_j = 1) 。 当有 (x) 个 (1) , (y) 个 (-1) 时,其满足条件的下标对数量为 (frac{x (x - 1)}{2} + frac{y (y - 1)}{2}) 。 由于 (n) 只有 (100) ,直接枚举 (x) 即可。

    2024年02月01日
    浏览(43)
  • Codeforces Round 871 (Div. 4)

    给定n个长度为10的字符串,问其与codeforces字符串的对应下标字母不同的个数。 对于每个字符串从前往后依次和“codeforces”对应字符比较然后统计不同字母数即可 给定长度为n的数组,问连续相邻为0的最大长度 维护一个全局最大长度res,和当前连续序列的长度cnt。从前往后扫

    2024年02月03日
    浏览(51)
  • Codeforces Round 867 (Div. 3)

    从所有a[i]+i-1=t的选择种取个max即可 实际上就是取同符号乘积的最大值 找规律,发现结果与边长n的关系是:res = n * (n + 3) - (n - 2) ①当n为奇数时,除了1其他均无解 ②当n为偶数时,我们可以构造一个形如n,1,n - 2,3,...的数列 首先我们可以发现n必定出现在起始位置。如果n不在起

    2024年02月02日
    浏览(45)
  • Codeforces Round 881 (Div. 3)

    给定一个数组,给每个元素涂色。求最大的代价。 代价为每个颜色的代价和。 每个颜色的代价为涂了该颜色的元素的极差。 因为是极差,每个元素要么对答案有正的贡献,要么有负的贡献,要么无贡献。且正负贡献的个数要相同。 因为要最大值,自然就是想有正贡献的是最

    2024年02月09日
    浏览(41)
  • Codeforces Round 912 (Div. 2)

    大等于2依据冒泡排序即可排序,因此判断下1即可 对每一个数字找哪一位肯定为0填0其他的填1 从后往前考虑加到当前集合或新立一个集合 从最高位开始考虑能否为1,计算能否时每个数当前位为1

    2024年02月04日
    浏览(43)
  • Codeforces Round 882 (Div. 2)

    目录 A. The Man who became a God  题目分析: B. Hamon Odyssey 题目分析: C. Vampiric Powers, anyone? 题目分析:  n个人分成k组,每一组的力量都是 这样的,那么如果分成k组那么就会有k-1个力量不被统计,将力量总和减去前k-1个最大的力量就是最小的结果   将数组分组,每个组内进行按位与

    2024年02月05日
    浏览(48)
  • Codeforces Round 894 (Div. 3)

    签到题 a数组里,大于等于前一个值的a[i]会被写到b里。直接遍历b,如果b[i]比前一个小就在它前面插一个相等的值 计算反过来的长度,判断是否相等就行 对于没有重复口味的集合,能选出的方案是n*(n-1)/2 (从n个里面选2个的组合数)。二分找出需要多少不同口味的冰淇淋,

    2024年02月11日
    浏览(43)
  • Codeforces Round 920 (Div. 3)

    Codeforces Round 920 (Div. 3) 题意:随机给出正方形在平面坐标系上的四个顶点的坐标,求正方形的面积,正方形边与xy轴平行。 思路:因为正方形与坐标轴平行,所以找出相同的两x或y坐标即可找到一条边的长度,平方就是面积,注意结果返回整型。 AC code: 题意:给出两个01字符

    2024年01月17日
    浏览(57)
  • Codeforces Round 918 (Div. 4)补题

    Odd One Out(Problem - A - Codeforces) 题目大意:有三个数,其中两个相同,找出不同的那个数。 Not Quite Latin Square(Problem - B - Codeforces) 题目大意:有一个3*3的矩阵,每行每列都由1,2,3三个元素构成,且同行同列中的元素不同,先有一个地方出现空缺,要求输出空缺位置的元素

    2024年02月01日
    浏览(36)
  • Codeforces Round 875 (Div. 1) 题解

    You are given two arrays a and b both of length n. Your task is to count the number of pairs of integers ( i , j ) (i,j) ( i , j ) such that 1 ≤ i j ≤ n 1≤ij≤n 1 ≤ i j ≤ n and a i ⋅ a j = b i + b j a_i⋅a_j=b_i+b_j a i ​ ⋅ a j ​ = b i ​ + b j ​ 。 1 ≤ a i , b i ≤ n 1≤a_i,b_i≤n 1 ≤ a i ​ , b i ​ ≤ n 考虑 m i n ( a i

    2024年02月08日
    浏览(41)

觉得文章有用就打赏一下文章作者

支付宝扫一扫打赏

博客赞助

微信扫一扫打赏

请作者喝杯咖啡吧~博客赞助

支付宝扫一扫领取红包,优惠每天领

二维码1

领取红包

二维码2

领红包